

;;;;;;;;;;;;;;;;;;;;;;  subrotina A ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                            ;Extrair código do operador (bits mais significativos)
                        
alineaA:        MOV R2, R1                  ;Move R1 para R2 para para não alterar o input; 
                SHR R2, 4                   ;Desloca 4 bits para a direita
                
                            ; Extrair código do número (bits do meio)
                            
                MOV R3, R1                  ; Move R1 para R3 para não alterar o imput
                SHR R3, 2                   ; Desloca 2 bits para a direita
                AND R3, 3                   ; Zera os bits mais a esquerda deixando apenas os 2 bits + significativos

                            ; Extrair código da letra (bits menos significativos)
                        
                MOV R4, R1                  ; Move R1 para R4 para para não alterar o imput
                AND R4, 3                   ; Zera os bits mais a esquerda deixando apenas os 2 bits + significativos
                RET                         ; Retornar da sub-rotina
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;; sub rotina B;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        
alineaB:        MOV R6, R1
proximacarta:   MOV R1, M[R6]               ; Passa para R1 a carta que esta na posicao de memoria da lista mais a R7 que é a conta cartas 
                CMP R1, 64                  ; Compara com 64 para verificar se é carta válida
                BR.N Descod                 ; Se R1-64 < 0 a carta é valida,  
                RET                         ; Retorna se R1-64 > 0
                
Descod:         CALL alineaA                ; Usa a subrotina alineaA para descodificar a carta

Operador:       CMP R2, R5                  ; Compara R2(codigo do operador) com R5 (iteradora)
                BR.Z memOperador            ; Se for igual, incrementa a frequência do operador 
                INC R5                      ; Incrementa o iterador
                BR Operador                 ; Volta a 'Operador' 

Numero:         CMP R3, R5                  ; Compara R3(codigo do numero) com a iteradora
                BR.Z memNumero              ; Se for igual, incrementa a frequência do número 
                INC R5                      ; Incrementa o iterador
                BR Numero                   ; Volta a 'Numero'

Letra:          CMP R4, R5                  ; Compara R4(codigo da Letra) com a iteradora
                BR.Z memLetra               ; Se for igual, incrementa a frequência da letra
                INC R5                      ; Incrementa o iterador
                BR Letra                    ; Volta a 'Letra'
                
memOperador:    INC M[R2+FreqOperador]      ; Incrementa a frequência do operador
                MOV R5, R0                  ; Reinicia o iterador
                BR Numero                   ; Salta para a próxima comparação
                
memNumero:      INC M[R3+FreqNumero]        ; Incrementa a frequência da letra
                MOV R5, R0                  ; Reinicia o iterador
                BR Letra                    ; Incrementa o contador de cartas     
                
memLetra:       INC M[R4+FreqLetra]         ; Incrementa a frequência da letra
                MOV R5, R0                  ; Reinicia o iterador 
                INC R6
                BR proximacarta   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





;;;;;;;;;;;;;;;;;;;;;;  subrotina C ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                                                                              
alineaC:        MOV R7, R2                  ; Guarda o valor da segunda carta             
                CALL alineaA                ; Descodifica a primeira carta 
                MOV R1, R7
                MOV R5, R2                  ; Mover o valor do operador da 1ªcarta           
                MOV R6, R3                  ; Mover o valor do número da 1ªcarta             
                MOV R7, R4                  ; Mover o valor do letra da 1ªcarta                                    
                CALL alineaA                ; Descodifica a segunda carta
                CMP R5, R2                  ; Compara os operadores
                BR.Z igual
                CMP R6, R3                  ; Compara os números   
                BR.Z igual
                CMP R7, R4                  ; Compara as letras
                BR.Z igual
                MOV R3, R0                  ; Coloca o valor 0 em R3
              
                RET

igual:          MOV R3, 1                   ;coloca o valor de 1 em R3
                RET
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;subrotina D ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

alineaD:        PUSH R1                      ; Move para stack 1º a lista 
                MOV R2, M[R1]                ; R2 fica com a 1ª carta da lista
                MOV M[8081h], R1             ; Guarda a posicao donde comeca a lista
             
           ;;;; Etiqueta para escolher a próxima carta na lista  ;;  
        
compara:        INC R1                       ; Avança para a próxima carta a comparar
                MOV R1, M[R1]                ; R1 fica com a próxima carta da lista
                CMP R1, 64                   ; Verificar se é carta válida
                BR.NN proxima                ; Se R1-64 < 0, a carta é válida
                CALL alineaC                 ; Descodifica e compara as cartas e retorna saída em R3
                CMP R3, 1                    ; Verifica se houve um tipo igual
                BR.NZ loop                   ; Se sim,salta para o contador 
                INC M[8080h]                 ; Incrementa ocontador de tipos iguais
loop:           POP R1                       ; Restaura a posição de memória da primeira carta da lista (8028)
                INC R1                       ; Aponta para a próxima carta na lista 
                PUSH R1                      ; Guarda esse valor na pilha
                MOV R2,M [8081h]             ; R2 fica com a posição de memoria primeira carta da lista
                MOV R2, M[R2]                ; R2 fica com a próxima carta da lista
                BR compara                   ; Volta para o início do loop
                
          ;;;;  para avançar para a próxima carta a compararar com a lista

proxima:        INC M[8081h]                 ; Atualiza a lista para a próxima carta 
                MOV R2, M[8081h]             ; R2 fica com a próxima carta da lista
                POP R0                       ; descarta 1 registo da pilha 
                PUSH R2                      ; actualiza o inicio da pilha
                MOV R1, R2                   ; Atualiza R1 a posicao da proxima carta
                MOV R2, M[R2]                ; R2 fica com a próxima carta da lista
                CMP R2, 64                   ; Verificar se é uma carta válida
                BR.NN fimdalista             ; Se carta invalida não há mais cartas para comparar
                BR compara                   ; Se carta valida volta para comparar  

fimdalista:     MOV R1, M[8080h]             ; R1 fica com a quantidade total de tipos iguais
                MOV M[8080h], R0             ; Reinicia o contador de tipos iguais
                POP R0                       ; Descarta o valor guardado na pilha
                RET                          ; Retorna da sub-rotina
                

                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                
